/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "SOAP" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package samples.interop;

import java.math.BigDecimal;
import java.util.Date;
import java.util.Hashtable;
import java.util.Map;

import org.apache.soap.encoding.Hex;

/** An implementation of the interop echo service as defined at
 * http://www.xmethods.net/ilab.
 * 
 * @author Glen Daniels (gdaniels@macromedia.com)
 */
public class EchoTestService
{
  public void nop()
  {
  }
  
  public int echoInteger(int i)
  {
    return i;
  }

  public float echoFloat(float f)
  {
    return f;
  }
  
  public String echoString(String str)
  {
    return str;
  }
  
  public Data echoStruct(Data data)
  {
    return data;
  }
  
  public int [] echoIntegerArray(int [] ii)
  {
    return ii;
  }
  
  public float [] echoFloatArray(float [] ff)
  {
    return ff;
  }
  
  public String [] echoStringArray(String [] ss)
  {
    return ss;
  }
  
  public Data [] echoStructArray(Data [] ds)
  {
    return ds;
  }
  
  public void echoVoid()
  {
  }
  
  public byte[] echoBase64(byte[] b64)
  {
    return b64;
  }
  
  public Hex echoHexBinary(Hex bytes)
  {
    return bytes;
  }
  
  public Date echoDate(Date d)
  {
    return d;
  }
  
  public BigDecimal echoDecimal(BigDecimal d)
  {
    return d;
  }
  
  public boolean echoBoolean(boolean b)
  {
    return b;
  }
  
  public Hashtable echoMap(Hashtable map)
  {
    return map;
  }
  
  public Map[] echoMapArray(Map[] mapmap)
  {
    return mapmap;
  }
}
